/*
 *  This file is part of the FREGENE package.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 
// *-*-C++-*-*
#ifndef STRING_CONVERTOR_H
#define STRING_CONVERTOR_H 1

#include "common.h"

/**
 *  Utility class used to convert string to other types.
 *  String can be enclosed to doouble quotes.
 */
class StringConvertor
{
public:
  static int toInt(const std::string& str);

  static double toFloat(const std::string& str);
  
  //static std::pair<int, int> toIntPair(const std::string& str);
  static void toIntPair(unsigned int *,const std::string& str);
  static void toIntPair(unsigned short *,const std::string& str);
  
  static bool isMissingValue(const std::string& str);
  static std::string dequote(const std::string& str);

};

#endif /* !STRING_CONVERTOR_H */
