/*
 *  This file is part of the FREGENE package.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 
//******************************************************************
//*
//*        REVISION HISTORY:
//*        $Log: fregene.h,v $
//*        Revision 1.8  2006/12/21 11:13:17  choggart
//*        some changes
//*
//*        Revision 1.7  2006/11/16 16:27:36  choggart
//*        loads of changes
//*
//*        Revision 1.6  2006/01/06 15:23:06  choggart
//*        Long time, many changes.
//*
//*        Revision 1.5  2005/10/04 13:07:05  choggart
//*        changes
//*
//*        Revision 1.4  2005/05/18 16:17:03  choggart
//*        Loads of changes - should commit more frequently
//*
//*        Revision 1.3  2005/04/08 15:19:57  choggart
//*        corrected code for hetrozygosity calculation
//*
//*        Revision 1.2  2005/03/07 15:15:12  choggart
//*        removed windows formatting
//*
//*        Revision 1.1.1.1  2005/03/04 15:13:36  ejo31
//*        imported sources
//*
//*
//******************************************************************

#ifndef FREGENE_H
#define FREGENE_H

#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cctype>
#include <iostream>
#include <bitset>
#include "rand.h"
#include "StringSplitter.h"
#include "StringConvertor.h"

#include "xml_file_write.h"
#include "xml_file_read.h"

#include "recomb2.h"

class Recomb2;

const uint32_t size = 100000;

bool ApplyTransmission(Recomb2&,
                       const uint32_t *_POPN, const uint32_t *_INDEX,
                       uint32_t *_NEWPOPN, uint32_t *_INDEXNEW,
                       uint32_t *Group_start, uint32_t *Group_end,
                       uint32_t *new_Group_start, uint32_t *new_Group_end,
                       uint32_t _PopnSizeNEWPOPN,
                       uint32_t _NoColPOPN, uint32_t _LastOccupiedElement,
		       std::bitset<size>&, std::bitset<size>&,
		       std::vector<uint32_t> &InvertedSites );

double homozigosity( uint32_t*, uint32_t*,
                     uint32_t*, uint32_t*,
                     uint32_t, uint32_t,
                     bool, uint32_t*, char* );
void StringToChar( char *c, std::string s );
int GetFPath(char *fname, char *pathname);
int GetFTitle(char *fname, char *titlename);

void logmsg(std::string message);
void logmsg(const char * message);
void logmsg(int number);
void logmsg(uint32_t number);
void logmsg(long number);
void logmsg(double number);

#endif
