/*
 *  This file is part of the FREGENE package.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 
//******************************************************************
//*
//*        REVISION HISTORY:
//*
//*        $Log: maerrno.h,v $
//*        Revision 1.2  2005/03/07 15:16:17  choggart
//*        removed windows formating
//*
//*        Revision 1.1.1.1  2005/03/04 15:13:36  ejo31
//*        imported sources
//*
//*        Revision 1.6  2002/08/02 07:55:38  sl64103
//*        changing ma_error code number
//*
//*        Revision 1.5  2002/07/29 09:08:25  sl64103
//*        MA_PM_NO_PEAK and MA_PM_NO_CORRELATION
//*
//*        Revision 1.4  2002/05/31 13:57:33  sl64103
//*        error allocating memory
//*
//*        Revision 1.3  2002/04/24 16:33:43  sl64103
//*        new number
//*
//*        Revision 1.2  2002/03/08 16:09:34  sl64103
//*        new error
//*
//*        Revision 1.1  2002/03/06 17:01:19  sl64103
//*        First Api Release
//*
//* 
//*         
//*
//******************************************************************


#ifndef MAERRNO_H

#define MAERRNO_H

/* Error Codes */
#define MA_ERROR          -10

/* NoErro Codes */		// 0 -> 10
#define MA_NO_ERROR			0 
#define MA_SUCCESS_EXEC		1 
#define MA_NO_ACTION			2  

/* File Errors */			// 11 -> 50
#define MA_WRITE_ERROR				11 
#define MA_READ_OPTION_ERROR		12 
#define MA_XML_FILE_ERROR			-13
#define MA_OPEN_FILE_ERROR			14
#define MA_CLOSE_FILE_ERROR	   15
#define MA_NULL_FILE_ERROR			16

/* Image Errors */			// 51 -> 100
#define MA_READ_IMAGE_ERROR		51 
#define MA_WRITE_IMAGE_ERROR		52 


/* Memory Errors */		// 101 -> 200
#define MA_NULL_ALLOCATION			101


/* Users Errors */		
#define MA_PM_NO_PEAK				-1
#define MA_PM_NO_CORRELATION		-2







#endif
