/*
 *  This file is part of the FREGENE package.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 

#include "maexcepcls.h"

/* MaException Class*/



////////////////////////////////
/* File Error Exceptions Class*/
////////////////////////////////
MaFileOpenException::MaFileOpenException (char *fname = NULL)
{
  str = NULL;
  if(fname) 
  {
	str = new char[1024];
	strcpy(str,fname);
  }
}

MaFileOpenException::~MaFileOpenException ()
{
  if(str) delete [] str; 
}

void MaFileOpenException::GetErrorMessage ()
{
 if(str) printf("Error During File Open %s\n",str);
 printf("Error During File Open\n");
}

const char *MaFileOpenException::GetFileName ()
{
	if(str) return str;
	else return "";
}

//////////////////////////////////////
/* Error of No Read in Command Line */
//////////////////////////////////////
MaCmdLineReadException::MaCmdLineReadException(char *option)
{
  str = NULL;
  if(option) 
  {
	str = new char[256];
	strcpy(str,option);
  }
}

MaCmdLineReadException::~MaCmdLineReadException()
{
  if(str) delete [] str; 
}

void MaCmdLineReadException::GetErrorMessage ()
{
  if(str) printf("\nThe option %s was not found\n",str);
  else printf("\nThe option was not found\n");
}


//////////////////////////////////////
/* Error of NULL XML MA file        */
//////////////////////////////////////
MaXmlFileException::MaXmlFileException(int e, const char *mess)
{
	SetError(e);
	SetMessage(mess);
}

MaXmlFileException::~MaXmlFileException()
{

}

void MaXmlFileException::GetErrorMessage ()
{
  if(str) printf("\n>>%s<<\n",str);
  else printf("\nError during MaXml prcessing\n");
}
