/*
 *  This file is part of the FREGENE package.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 
// *-*-C++-*-*
#ifndef RECOMB2_H
#define RECOMB2_H 1

#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <vector>

void StringToChar( char *c, std::string s );

class Recomb2
{
  public:
  Recomb2(uint32_t, double, uint32_t, double,
	  double, double, uint32_t, char* nameIN );
   void GetRecombinations(std::vector<uint32_t>&);
   void UpdateRecombinationRate( double );
   double GetRecombinationRate();
  private:
   double OverallRate;
   uint32_t GC_LENGTH;
   double GC_RATE;
   uint32_t RegionLength;
   unsigned short SubsPerRegion;
   uint32_t SubLength;
   float FractionInHS;
   uint32_t HotSpotLength;
   uint32_t ChromoLength;
   uint32_t Regions;
   std::vector<double> RegionRates;
   std::vector< uint32_t > RegionPosn;
   std::vector< std::vector< double > > SubRate;
   std::vector< std::vector< uint32_t > > SubPosn;
   std::vector< std::vector< std::vector< uint32_t > > > HS_posn;
   std::vector< std::vector< std::vector< double > > > HS_intensity;
};

#endif /* !defined RECOMB2_H */
