/*
 *  This file is part of FREGENE program.
 *  Copyright (c) Clive J Hoggart   <c.hoggart@imperial.ac.uk>
 *                Taane G Clark     <tgc@well.ox.ac.uk>
 *                Marc Chadeau      <m.chadeau@imperial.ac.uk>
 *
 *  FREGENE is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  FREGENE is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */ 

#include <vector>
#include <bitset>

#ifndef PHENOTYPE_H
#define PHENOTYPE_H

const unsigned long size = 1000000;

void GetDiseaseSNP(unsigned long, short, unsigned long, double*);
void SetDiseaseModel(short, double, unsigned short, double*, std::vector<double>* );
void SetDiseaseModel_quant( unsigned short, double* );
short GetPhenotype(short, unsigned short, unsigned long, unsigned long, std::vector<std::bitset<size> >& );
double GetPhenotype_quant( unsigned short, unsigned long, unsigned long, std::vector<std::bitset<size> >& );

#endif
